from SapTrap_Builder import SapTrap_Reference as STR

sequence1 = 'GAGATAGAGACACACGATAGACACAGTGAC'
sequence2 = 'YRY'


def find_next_instance(subject_sequence, query_sequence):
    """ returns position of next instance of query_sequence in subject_sequence; degenerate search """
    for i in range(len(subject_sequence) - len(query_sequence) + 1):
        i_query = 0
        while i_query < len(query_sequence):
            local_base_set = set(STR.degenerate_DNA_code[subject_sequence[i]])
            query_base_set = set(STR.degenerate_DNA_code[query_sequence[i_query]])
            if local_base_set & query_base_set:
                i += 1
                i_query += 1
            else:
                break
        if i_query == len(query_sequence):
            return i - len(query_sequence)

    return -1

def is_match(seq1, seq2):
    assert len(seq1) == len(seq2)
    for pair in zip(seq1, seq2):
        if not set(STR.degenerate_DNA_code[pair[0]]) & set(STR.degenerate_DNA_code[pair[1]]):
            return False
    return True

def find_next_instance_2(seq1, seq2):
    for i in range(len(seq1) - len(seq2) + 1):
        if is_match(seq1[i:i+len(seq2)], seq2):
            return i
    return -1

print(find_next_instance(sequence1, sequence2))
print(find_next_instance_2(sequence1, sequence2))

print(max(-1, -1))
print(min(-1, -1))


found_locations = []
        next_search_start = start
        rc_query_sequence = DNA(query_sequence).reverse_complement()
        while next_search_start >= 0:
            next_search_start = DNA(self.sequence).find(query_sequence, start=next_search_start,
                                                        case_sensitive=case_sensitive, search_rev_com=search_rev_com)
            if next_search_start >= 0:
                found_locations.append(next_search_start)
                if search_rev_com == True:
                    if query_sequence.upper() != str(rc_query_sequence).upper():
                        if DNA(self.sequence).find(rc_query_sequence, start=next_search_start,
                                                   case_sensitive=case_sensitive, search_rev_com=False) == \
                                DNA(self.sequence).find(query_sequence, start=next_search_start,
                                                        case_sensitive=case_sensitive, search_rev_com=False):
                            found_locations.append(next_search_start)
                next_search_start += 1

        return found_locations
